#!/bin/bash

# clear directories
#rm -rf /L1Pipeline/L0/*
#rm -rf /L1Pipeline/L1/*

# obsid 100000100 ~ 100000154
python /L1Pipeline/build/csst_l1/app/l1_mbi_tcc.py $1 > /work/stdout 2> /work/stderr

exit_code=$?

# 标准错误和标准输出，输出到文件
echo "obsid : "$1 >> /var/log/scalebox/stdout
cat /work/stdout >> /var/log/scalebox/stdout

echo "obsid : "$1 >> /var/log/scalebox/stderr
cat /work/stderr >> /var/log/scalebox/stderr

rm -f /work/stdout /work/stderr

obsid=$1
#cat /L1Pipeline/L1/csst-l1ppl.log
#cat /L1Pipeline/L1/csst-l1ppl.log >> /var/log/scalebox/${obsid}.log
#创建临时文件
touch /L1Pipeline/L1/csst-l1mod-tmp.log
#取/L1Pipeline/L1/csst-l1mod.log后100行
cat /L1Pipeline/L1/csst-l1mod.log|tail -n 100 > /L1Pipeline/L1/csst-l1mod-tmp.log
# log文件记录到标准错误或标准输出
cat /L1Pipeline/L1/csst-l1ppl.log /L1Pipeline/L1/csst-l1mod-tmp.log
cat /L1Pipeline/L1/csst-l1ppl.log /L1Pipeline/L1/csst-l1mod-tmp.log >> /var/log/scalebox/${obsid}.log

rm -rf /L1Pipeline/L0/* /L1Pipeline/L1/*

# do timestamps
ts=""
if [ -f "/tmp/timestamps.txt" ]; then
    mapfile arr < /tmp/timestamps.txt
    for e in ${arr[@]}; do
       # e=${e:0:-5}
       # e+="+08:00"
       # e=$(echo $e|tr ',' '.')
        ts+=\"${e}\"\,
    done
    # skip the last ','
    ts=${ts:0:-1}
    rm -f /tmp/timestamps.txt

cat << EOF > /work/record.json
{
    "timestamps":[${ts}]
}
EOF

fi




echo finish mbi.

exit $exit_code
